//+------------------------------------------------------------------+ 
//|   TRO_MM_REVERSAL                                                | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

#property indicator_chart_window
  
extern int  yAxis = 0 ;
extern int  Corner = 1;


extern int       Length = 10; // Period of evaluation
extern int       Smooth =  5; // Period of smoothing
extern int       ModeMA =  1; // Mode of Moving Average



extern color UpColor   =Lime;
extern color DownColor =Red;
extern color FlatColor =Yellow;
extern color TextColor =DodgerBlue;





int tframe[]={1,5,15,30,60,240,1440,10080,43200};

string tf[]={"M1","M5","M15","M30","H1","H4","D1","W1","MN"};

int tfnumber=9;  

double cValue, pValue;

string TimeFrameStr;
double IndVal[9];

int xpos[9], ypos[9];
int w , j , xposTAG;

string TAG = "mmREV" ;

string ArrowHeadRt =  "" ; // 216 up arrow head
string ArrowHeadUp =  "" ; // 217 up arrow head
string ArrowHeadDn =  "" ; // 218 up arrow head 

string theArrow[9];
color  theColor[9];

double HC[],LC[];
double haOpen, haHigh, haLow, haClose;
double haOpen1, haHigh1, haLow1, haClose1;
int pos ;

//+------------------------------------------------------------------+
int init()
{

deinit();

if(Corner == 1 || Corner == 3)
{ 
   for( w = 0 ; w < tfnumber ; w++) { xpos[w] = 15 + ((9 - w)*23)  ; } 
   xposTAG = 240 ;
} 
else
{
   for( w=0;w<tfnumber;w++) { xpos[w] = w*23 + 50 ; }
   xposTAG = 10 ;
}

         ObjectCreate(TAG+"HD",OBJ_LABEL,0,0,0,0,0);
         ObjectSet(TAG+"HD",OBJPROP_CORNER,Corner);
         ObjectSet(TAG+"HD",OBJPROP_XDISTANCE,xposTAG);
         ObjectSet(TAG+"HD",OBJPROP_YDISTANCE,yAxis+30);
         ObjectSetText(TAG+"HD",TAG,8,"Tahoma",TextColor);

   for( w=0;w<tfnumber;w++)
      {
         ObjectCreate(TAG+tf[w],OBJ_LABEL,0,0,0,0,0);
         ObjectSet(TAG+tf[w],OBJPROP_CORNER,Corner);
         ObjectSet(TAG+tf[w],OBJPROP_XDISTANCE,xpos[w]);
         ObjectSet(TAG+tf[w],OBJPROP_YDISTANCE,yAxis+20);
         ObjectSetText(TAG+tf[w],tf[w],8,"Tahoma",TextColor);
      }

//----
   
   
   return(0);
  } 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
        
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {

   ArrayResize(HC, 2) ;  
   ArrayResize(LC, 2) ;
   
//----
   

   for( j=0;j<tfnumber ;j++)
   {
      if (ObjectFind(TAG+j) != 0)
      {
         ObjectCreate(TAG+j,OBJ_LABEL,0,0,0,0,0);
         ObjectSet(TAG+j,OBJPROP_CORNER,Corner);
         ObjectSet(TAG+j,OBJPROP_XDISTANCE,xpos[j]);
         ObjectSet(TAG+j,OBJPROP_YDISTANCE,yAxis+30);
         ObjectSetText(TAG+j,CharToStr(110),12,"Wingdings",White);
      }// if
   } // for

      
   for(int x=0;x<tfnumber;x++)
   {
   
      pos     = 0 ;
      haOpen  = iOpen(NULL, tframe[x], pos) ;
      haClose = iClose(NULL, tframe[x], pos) ;
      haHigh  = iHigh(NULL, tframe[x], pos) ;
      haLow   = iLow(NULL, tframe[x], pos) ;


      haOpen1  = iOpen(NULL, tframe[x], 1) ;
      haClose1 = iClose(NULL, tframe[x], 1) ;
      haHigh1  = iHigh(NULL, tframe[x], 1) ;
      haLow1   = iLow(NULL, tframe[x], 1) ;
      
      HC[pos] = haHigh  - haClose ;
      LC[pos] = haClose - haLow  ;

      HC[1] = haHigh1  - haClose1 ;
      LC[1] = haClose1 - haLow1  ;

      if (HC[pos] > HC[pos+1]  && haClose > haClose1 && haClose > haOpen && haClose1 > haOpen1 )
        {
         theArrow[x] = ArrowHeadDn ;
         theColor[x] = DownColor ;            
        } 
      else
      if (LC[pos] > LC[pos+1]  && haClose < haClose1 && haClose < haOpen && haClose1 < haOpen1 )
        {
         theArrow[x] = ArrowHeadUp ;
         theColor[x] = UpColor ;       
        } 
      else  
        {
         theArrow[x] = ArrowHeadRt ;
         theColor[x] = FlatColor ;      
        }   // if   
   }
   
   
      for(int y=0;y<tfnumber;y++)
      {
         ObjectSetText(TAG+y,theArrow[y],12,"Wingdings",theColor[y]);
      }  
        
   
//----
   return(0);
  }

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+